<?php
ini_set('serialize_precision', 14);
ini_set('precision', 14);
include '../../init/db.php';
include '../../init/functions.php';

$params = file_get_contents('php://input');
$params = json_decode($params);

$company_id = $params->company_id;
$payee_id = $params->payee_id;
$payment_instruction_id = $params->payment_instruction_id;
$invoice_id = $params->invoice_id;
$invoice_date = $params->invoice_date;
$invoice_description = $params->invoice_description;
$invoice_slip = $params->invoice_slip;
$selected_currency = $params->selected_currency;
$amount = $params->amount;
$rate = $params->rate;
$status = 'Deposits in Review';
$created_at = $updated_at = time();

$file_name = 'INV_'.$invoice_id.'_'.$created_at.'.png';
file_put_contents('../../assets/img/invoice/'.$file_name, base64_decode($invoice_slip));

$payment_request_id = get_uuid();
$query = "insert into payment_request (id, company_id, payee_id, payment_instruction_id, invoice_id, invoice_date, invoice_description, invoice_slip, selected_currency, amount, rate, status, created_at, updated_at) values ('$payment_request_id', '$company_id', '$payee_id', '$payment_instruction_id', '$invoice_id', '$invoice_date', '$invoice_description', '$file_name', '$selected_currency', '$amount', '$rate', '$status', '$created_at', '$updated_at')";
$result = mysqli_query($db, $query);

if($result){
    $balance_id = get_uuid();
    $operation_date = date('m/d/Y', time());
    $registration_datetime = date('m/d/Y H:i:s', time());
    $query = "insert into balance (id, company_id, bank_id, operation_type, operation_id, currency, operation_amount, operation_date, reference_number, slip_file, registration_datetime, operation_status, operation_reviewer, operation_reviewer_evidence, operation_review_datetime) values ('$balance_id', '$company_id', '', 'payment', '$payment_request_id', '$selected_currency', '$amount', '$operation_date', '', '$file_name', '$registration_datetime', 'Unverified', '', '', '')";
    mysqli_query($db, $query);
    
    $rates = [];
    $currencies = [];
    $query = "select * from currency";
    $result = mysqli_query($db, $query);
    while($row = mysqli_fetch_assoc($result)){
        array_push($currencies, $row['currency']);
        $rates[$row['currency']] = (float)$row['rate'];
    }
    $key = array_search($selected_currency, $currencies);
    unset($currencies[$key]);
    array_unshift($currencies, $selected_currency);

    $query = "select verified_balance from company where id = '$company_id'";
    $result = mysqli_query($db, $query);
    $verified_balance = mysqli_fetch_assoc($result)['verified_balance'];
    $verified_balance = json_decode($verified_balance, true);
    
    foreach($currencies as $currency){
        if($verified_balance[$currency] * ($rates[$currency] / $rates[$selected_currency]) >= $amount){
            $verified_balance[$currency] -= $amount * ($rates[$selected_currency] / $rates[$currency]);
            $verified_balance[$currency] = round($verified_balance[$currency], 2, PHP_ROUND_HALF_DOWN);
            $amount = 0;
        }
        else{
            $amount -= $verified_balance[$currency] * ($rates[$currency] / $rates[$selected_currency]);
            $verified_balance[$currency] = 0;
        }
        if($amount <= 0){
            break;
        }
    }
    $verified_balance = json_encode($verified_balance, JSON_PRESERVE_ZERO_FRACTION);
    
    $query = "update company set verified_balance = '$verified_balance' where id = '$company_id'";
    mysqli_query($db, $query);
    
    echo 'success';
}
else{
    echo 'fail';
}
?>